Codeforces 474D Flowers【dp】

来源:互联网 发布:透明相机软件下载 编辑:程序博客网 时间:2024/04/29 03:59

D.  Flowers
time limit per test
1.5 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

We saw the little game Marmot made for Mole's lunch. Now it's Marmot's dinner time and, as we all know, Marmot eats flowers. At every dinner he eats some red and white flowers. Therefore a dinner can be represented as a sequence of several flowers, some of them white and some of them red.

But, for a dinner to be tasty, there is a rule: Marmot wants to eat white flowers only in groups of sizek.

Now Marmot wonders in how many ways he can eat between a and b flowers. As the number of ways could be very large, print it modulo1000000007 (109 + 7).

Input

Input contains several test cases.

The first line contains two integers t andk (1 ≤ t, k ≤ 105), wheret represents the number of test cases.

The next t lines contain two integers ai and bi (1 ≤ ai ≤ bi ≤ 105), describing thei-th test.

Output

Print t lines to the standard output. Thei-th line should contain the number of ways in which Marmot can eat betweenai andbi flowers at dinner modulo1000000007 (109 + 7).

Examples
Input
3 21 32 34 4
Output
655
Note
  • For K = 2 and length1 Marmot can eat (R).
  • For K = 2 and length2 Marmot can eat (RR) and (WW).
  • For K = 2 and length3 Marmot can eat (RRR), (RWW) and (WWR).
  • For K = 2 and length4 Marmot can eat, for example, (WWWW) or (RWWR), but for example he can't eat (WWWR). 
题目大意:

一共有t次询问,询问为长度从ai到bi长度区间内,有多少个合法的放置方式。

合法的放置方式指的是:如果有一个白色的花,那么其相邻的连续的白色的花必须有k个。


思路:


1、设定dp【i】表示长度为i的情况有多少合法放置方式。


dp【i】=dp【i-1】+dp【i-k】;

长度为i-1的时候,直接在其每个合法的放置方式的右边多加一个红色的花也都是合法的情况。

长度为i-k的时候,直接在其每个合法的放置方式的右边多加k个连续白色的花也都是合法的情况。

那么累加即可。


2、然后我们维护一个前缀和即可。那么答案就是sum【bi】-sum【ai】,因为sum【i】是取模之后的sum值,那么sum【bi】-sum【ai】可能是一个负数,那么对应结果应该是:

(sum【bi】-sum【ai】+mod)%mod;


Ac代码:

#include<stdio.h>#include<string.h>using namespace std;#define ll __int64ll f[100050];ll sum[100050];int main(){    int t,k;    while(~scanf("%d%d",&t,&k))    {        for(int i=0;i<=100000;i++)        {            if(i<k)f[i]=1;            else            {                f[i]=f[i-1]+f[i-k];            }            f[i]%=1000000007;        }        sum[1]=f[1];        for(int i=2;i<=100000;i++)        {            sum[i]=sum[i-1]+f[i];            sum[i]%=1000000007;        }        while(t--)        {            int x,y;            scanf("%d%d",&x,&y);            printf("%I64d\n",(sum[y]-sum[x-1]+1000000007)%1000000007);        }    }}





0 0